/*  spadm.c  - administrador do spool */

#include <stdio.h>
#include <signal.h>
#include "spool.h"

main ()
{
  char cmd [128];
  int ret;

  while (1) {
    printf ("*");
    gets (cmd);
    ret = ERRO;
    switch (cmd [0]) {
      case 'a': 
        switch (cmd [1]) {
          case 's': ret = ativa_spool(); break;
          case 'i': ret = ativa_imp (cmd); break;
          case 'p': ret = avanca_pag (cmd); break;
          case 'b': ret = abandona_imp (cmd); break;
          case 'c': ret = altera_copias (cmd); break;
        }
        break;
      case 'c':
        if (cmd [1] == 'i')
          ret = cont_imp (cmd);
        break;
      case 'd':
        switch (cmd [1]) {
          case 's' : ret = desat_spool(); break;
          case 'i' : ret = desat_imp (cmd); break;
        }
        break;
      case 'f':
        if (strlen (cmd) == 1)
          exit (0);
      case 'i': 
        if (cmd [1] == 'n')
          ret = imp_denovo (cmd);
        break;
      case 'h':
        if (strlen (cmd) == 1)
          ret = help ();
        break;
      case 'l':
        switch (cmd [1]) {
          case 's': ret = lista_fila (cmd); break;
          case 'i': ret = lista_impressora (cmd); break;
        }
        break;
      case 'm':
        if (cmd [1] == 'f') 
          ret = muda_forms (cmd);
        break;
      case 'p':
        if (cmd [1] == 'i')
          ret = para_imp (cmd);
        break;
      case 'r':
        switch (cmd [1]) {
          case 'i': ret = rem_impresso(cmd); break;
          case 'r': ret = rem_rel (cmd); break;
        }
        break;
      case 't':
        switch (cmd [1]) {
          case 'f': ret = troca_forms (cmd); break;
          case 'i': ret = troca_imp (cmd); break;
        }
        break;
      case 'v':
        if (cmd [1] == 'p')
          ret = volta_pag  (cmd);
        break;
      default: break;
    }
    if (ret == ERRO)
      printf ("spadm: 'h' para ajuda.\n");
  } 
}

help ()
{
  printf ("h            -> lista este texto\n");
  printf ("f            -> sai do programa\n");
  printf ("as           -> ativa o spool\n");
  printf ("ds           -> desativa o spool\n");
  printf ("ai imp       -> ativa a impressora especificada por 'imp'\n");
  printf ("di imp       -> desativa a impressora especificada por 'imp'\n");
  printf ("mf forms imp -> define o formulario");
  printf (" 'forms' como corrente na impressora 'imp'\n");
  printf ("li [imp]     -> lista o estado da impressora 'imp'\n");
  printf ("ls [imp]     -> lista a fila de impressao da impressora 'imp'\n");
  printf ("tf forms req -> troca para o formulario 'forms'");
  printf (" o relatorio n. 'req'\n");
  printf ("ti imp req   -> troca o relatorio 'req' para a impressora 'imp'\n");
  printf ("ac ncop  req -> altera 'ncop' copias do relatorio n. 'req'\n");
  printf ("in req       -> imprime novamente o relatorio n. 'req'\n");
  printf ("ri           -> remove todos os relatorios ja impressos\n");
  printf ("rr  req      -> remove o relatorio 'req' da fila\n");
  printf ("pi imp       -> para a impressao na impressora 'imp'\n");
  printf ("ci imp       -> continua a impressao na impressora 'imp'\n");
  printf ("ap pag imp   -> avanca 'pag' paginas na impressora 'imp'\n");
  printf ("vp pag imp   -> volta 'pag' paginas na impressora 'imp'\n");
  printf ("ab imp       -> abandona a impressao na impressora 'imp'\n");
  return (OK);
}

/* as  -  ativa spool */

ativa_spool ()
{
  FILE *fd, *fdfila, *fdnew;
  int pid, seq, seqant;
  char pida [10], seqa [10], bufreq [512], estado [10];
  char cmd [512];
  
  pid=le_pid ();
  if (kill (pid, SIGUSR1) == OK) {
      printf ("spadm: Spool ja esta ativo (pid = %d)\n", pid);
      return (ERRO);
  }
  if ((fdfila = fopen (TABFILA, "r")) == NULL) {
    printf ("spadm: Erro na abertura do arquivo %s\n", TABFILA);	
    return (ERRO);
  }
  if ((fdnew = fopen (TABNFILA, "w")) == NULL) {
    printf ("spadm: Erro na abertura do arquivo %s\n", TABNFILA);	
    return (ERRO); 
  }
  seqant=0;
  while (fgets (bufreq, TAMFIL, fdfila) != NULL) {
    pega_cpo (bufreq, FILSTA, estado);
    if (!strcmp (estado, DELETADO))
      continue;
    pega_cpo (bufreq, FILREQ, seqa);
    seq=atoi (seqa);
    if (seq > seqant)
      seqant = seq;
    fputs (bufreq, fdnew);
  }
  fclose (fdfila);
  fclose (fdnew);
  /* mv TABNFILA TABFILA */
  strcpy (cmd, "mv ");
  strcat (cmd, TABNFILA);
  strcat (cmd, " ");
  strcat (cmd, TABFILA);
  system (cmd);
  grava_sequencia (seqant);
  system ("spool &");
  return (OK);
}

/* ds  -  desativa spool */

desat_spool ()
{
  int pid;

  pid=le_pid ();
  if (kill (pid, SIGUSR1) == ERRO) {
    printf ("spadm: Spool nao esta ativo.\n");
    return (ERRO);
  }
  kill (pid, SIGKILL);
  return (OK);
}

/* ai imp  -  ativa impressora 'imp' */

ativa_imp (cmd)
char *cmd;
{
  char bufimp [512], imp [128], estado [128];

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  pega_cpo (bufimp, IMPEST, estado);
  if (strcmp (estado, ATIVADA) == OK) {
    printf ("spadm: A impressora %s ja ativa.\n", imp);
    return (ERRO);
  }
  strcpy (estado, ATIVADA);
  poe_cpo (bufimp, IMPEST, estado);
  grava_imp (imp, bufimp);
  kill (le_pid (), SIGUSR1);
  return (OK);
}

/* av pag imp  -  avanca 'pag(s)' na impressora 'imp' */

avanca_pag (cmd)
char *cmd;
{
  char bufimp [512], imp [128], estado [128], pag [128], pida [128],
       cmdimp [128];
  int pid;

  if (pega_linha_cmd (cmd, 2, pag) == ERRO)
    return (ERRO);
  if (pega_linha_cmd (cmd, 3, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPEST, estado) == ERRO)
    return (ERRO);
  if (strcmp (estado, IMPRIMINDO) != OK) {
     printf ("spadm: impressora %s nao esta imprimindo.\n", imp);
     return (ERRO);
  }
  if (pega_cpo (bufimp, IMPPID, pida) == ERRO)
    return (ERRO);
  pid=atoi (pida);
  strcpy (cmdimp, AVANCAPAG);
  strcat (cmdimp, pag);
  poe_cpo (bufimp, IMPCMD, cmdimp);
  grava_imp (imp, bufimp);
  kill (pid, SIGUSR1);
  return (OK);
}

/* ab imp  -  abandona impressao na impressora 'imp' */

abandona_imp (cmd)
char *cmd;
{
  char bufimp [512], imp [128], estado [128], pida [128], cmdimp [128];
  int pid;

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPEST, estado) == ERRO)
    return (ERRO);
  if (strcmp (estado, IMPRIMINDO) != OK) {
    printf ("spadm: impressora %s nao esta imprimindo.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPPID, pida) == ERRO)
    return (ERRO);
  pid=atoi (pida);
  strcpy (cmdimp, ABANDONE);
  poe_cpo (bufimp, IMPCMD, cmdimp);
  grava_imp (imp, bufimp);
  kill (pid, SIGUSR1);
  return (OK);
}

/* ac ncop req  -  altera o numero de copias da requisicao 'req' */

altera_copias (cmd)
char *cmd;
{
  char bufreq [512], req [128], copias [128];
  int aux;

  if (pega_linha_cmd (cmd, 2, copias) == ERRO)
    return (ERRO);
  aux=atoi (copias);
  sprintf (copias, "%d", aux);
  if (pega_linha_cmd (cmd, 3, req) == ERRO)
    return (ERRO);
  if (le_req (req, bufreq) == ERRO) {
    printf ("spadm: Nao existe a requisicao %s", req);
    return (ERRO);
  }
  poe_cpo (bufreq, FILCOP, copias);
  grava_req (req, bufreq);
  return (OK);
}

/* ci imp  -  continua impressao na impressora 'imp' */

cont_imp (cmd)
char *cmd;
{
  char bufimp [512], imp [128], estado [128], pida [128],
        cmdimp [128];
  int pid;

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPEST, estado) == ERRO)
    return (ERRO);
  if (strcmp (estado, IMPRIMINDO)) {
    printf ("spadm: impressora %s nao esta imprimindo.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPPID, pida) == ERRO)
    return (ERRO);
  pid=atoi (pida);
  strcpy (cmdimp, CONTINUAIMPR);
  poe_cpo (bufimp, IMPCMD, cmdimp);
  grava_imp (imp, bufimp);
  kill (pid, SIGUSR1);
  return (OK);
}

/* di imp  -  desabilita a impressao na impressora 'imp' */

desat_imp (cmd)
char *cmd;
{
  char bufimp [512], imp [128], estado [128];

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPEST, estado) == ERRO)
    return (ERRO);
  if (strcmp (estado, DESATIVADA) == OK) {
    printf ("spadm: A impressora %s ja esta desativada.\n", imp);
    return (ERRO);
  }
  strcpy (estado, DESATIVADA);
  poe_cpo (bufimp, IMPEST, estado);
  grava_imp (imp, bufimp);
  return (OK);
}

/* in req  -  imprime novamente a requisicao 'req' */

imp_denovo (cmd)
char *cmd;
{
  char bufreq [512], req [128], estado [128];
  int aux;

  if (pega_linha_cmd (cmd, 2, req) == ERRO)
    return (ERRO);
  if (le_req (req, bufreq) == ERRO) {
    printf ("spadm: Nao existe requisicao %s.\n", req);
    return (ERRO);
  }
  strcpy (estado, REIMPRIMIR);
  poe_cpo (bufreq, FILSIT, estado);
  grava_req (req, bufreq);
  kill (le_pid (), SIGUSR1);
  return (OK);
}

lista_impressora (cmd)
char *cmd;
{ 
  char imp [30];

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (lista_todos_imp ());
  else 
    return (lista_imp (imp));
}

/* ls [imp] */

lista_fila (cmd)
char *cmd;
{
  FILE *fd;
  char req [60], usuario [60], impr [60], titulo [60], arq [60],
       forms [60], pag [60], copia [60], data [60], hora [60],
       estado [60], imp [128], bufreq [512], aux [60];
  int i;

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    strcpy (imp, STRNULO);
  if ((fd=fopen (TABFILA, "r"))==NULL) {
    printf ("Erro na abertura do arquivo %s \n", TABFILA);
    return (ERRO);
  }
  printf ("REQ. USUARIO  IMPRESSORA   ARQUIVO");
  printf ("        FORMULARIO    PAG. COPIA  ESTADO\n");
  printf ("----------------------------------------------");
  printf ("--------------------------------\n");
  printf ("       DATA       HORA      TITULO\n");

  while (fgets (bufreq, TAMFIL*2, fd) != NULL) {
    if (pega_cpo (bufreq, FILSTA, estado) == ERRO)
      return (ERRO);
    if (strcmp (estado, ATIVO) != OK)
      continue;
    if (pega_cpo (bufreq, FILIMP, impr) == ERRO)
      return (ERRO);
    if (strlen (imp) > 0)
      if  (strcmp (imp, impr) != OK)
        continue; 
    if (pega_cpo (bufreq, FILREQ, req) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILUSU, usuario) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILIMP, impr) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILTIT, titulo) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILARQ, arq) == ERRO)
      return (ERRO);
    /* Pega o nome do relatorio no sistema */
    for (i = strlen (arq); i > 0; i--) 
      if (arq [i] == '/') {
        i++;
        strcpy (aux, &arq [i]);
        strcpy (arq, aux);
        break;
    }
    if (pega_cpo (bufreq, FILFOR, forms) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILPAG, pag) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILCOP, copia) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILDAT, data) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILHOR, hora) == ERRO)
      return (ERRO);
    if (pega_cpo (bufreq, FILSIT, estado) == ERRO)
      return (ERRO);
    if (!strcmp (estado, SENDOIMPRESSO))
      strcpy (estado, "Sendo Impr");
    else
      if (!strcmp (estado, AGUARDANDOIMPR))
        strcpy (estado, "Aguardando");
      else
        if (!strcmp (estado, IMPRESSO))
          strcpy (estado, "Impresso");
    printf ("%-4.4s %-8.8s %-12.12s %-14.14s %-17.17s %-1.4s %2.5s  %5.10s\n", 
            req, usuario, impr, arq, forms, pag, copia, estado);
    printf ("     %-10.10s %-11.11s %-35.35s\n", 
            data, hora, titulo);
  } 
  fclose (fd);
}

/* mf forms imp  -  muda o formulario da impressora 'imp' para 'forms' */

muda_forms (cmd)
char *cmd;
{
  char bufimp [512], imp [128], forms [128];

  if (pega_linha_cmd (cmd, 2, forms) == ERRO) 
    return (ERRO);
  if (pega_linha_cmd (cmd, 3, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  poe_cpo (bufimp, IMPFOR, forms);
  grava_imp (imp, bufimp);
  kill (le_pid (), SIGUSR1);
  return (OK);
}

/* pi imp  -  para a impressao na impressora 'imp' */ 

para_imp (cmd)
char *cmd; {

  char bufimp [512], imp [128], estado [128], pida [128],
       cmdimp [128];
  int pid;

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (ERRO);
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: A impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPEST, estado) == ERRO)
    return (ERRO);
  if (strcmp (estado, IMPRIMINDO)) {
    printf ("spadm: impressora %s nao esta imprimindo.\n", imp);
    return (ERRO);
  }
  if (pega_cpo (bufimp, IMPPID, pida) == ERRO)
    return (ERRO);
  pid=atoi (pida);
  strcpy (cmdimp, PARARIMPR);
  poe_cpo (bufimp, IMPCMD, cmdimp);
  grava_imp (imp, bufimp);
  kill (pid, SIGUSR1);
  return (OK);
}

/* ri  -  remove todas as requisicoes */

rem_impresso (cmd)
char *cmd;
{
  char bufreq [512];
  FILE *fd;

  if ((fd=fopen (TABFILA, "r+w"))==NULL) {
    printf ("spadm: erro na abertura do arquivo %s.\n", TABFILA);
    exit (0);
  }
  while (fgets (bufreq, 512, fd) != NULL) {
    char estado [128], arq [128], cmdrm [128], req [20];
    int i;

    pega_cpo (bufreq, FILSIT, estado);
    if (strcmp (estado, IMPRESSO))  
      continue;
    pega_cpo (bufreq, FILSTA, estado);
    if (!strcmp (estado, DELETADO))
      continue;
    pega_cpo (bufreq, FILREQ, req); 
    poe_cpo (bufreq, FILSTA, DELETADO);
    for (i=1; i < 256; i++)
      if (bufreq [i] == LF)
        bufreq [i]=BRANCO;
    bufreq [256]=LF;
    bufreq [257]=NULO;
    grava_req (req, bufreq);
    pega_cpo (bufreq, FILARQ, arq);
    strcpy (cmdrm, "rm ");
    strcat (cmdrm, arq);
    system (cmdrm); 
  }
  fclose (fd);
  return (OK);
}

/* rr req  -  remove a requisicao 'req' */

rem_rel (cmd)
char *cmd;
{
  char bufreq [512], req [128], estado [128], arq [128], cmdrm [128];

  if (pega_linha_cmd (cmd, 2, req) == ERRO)
    return (ERRO);
  if (le_req (req, bufreq) == ERRO) {
    printf ("spadm: nao existe requisicao %s.\n", req);
    return (ERRO);
  }
  pega_cpo (bufreq, FILSTA, estado);
  if (!strcmp (estado, DELETADO)) {
    printf ("spadm: A requisicao %s ja esta deletada.\n", req);
    return (ERRO);
  } 
  strcpy (estado, DELETADO);
  poe_cpo (bufreq, FILSTA, estado);
  grava_req (req, bufreq);
  if (pega_cpo (bufreq, FILARQ, arq) == ERRO)
    return (ERRO);
  strcpy (cmdrm, "rm ");
  strcat (cmdrm, arq);
  system (cmdrm); 
  return (OK);
}

/* tf forms req  -  troca o formulario da requisicao 'req' para 'forms' */

troca_forms (cmd)
char *cmd;
{
  char bufreq [512], req [128], forms [128];

  if (pega_linha_cmd (cmd, 2, forms) == ERRO)
    return (ERRO);
  if (pega_linha_cmd (cmd, 3, req) == ERRO)
    return (ERRO);
  if (le_req (req, bufreq) == ERRO) {
    printf ("spadm: nao existe requisicao %s.\n", req);
    return (ERRO);
  }
  poe_cpo (bufreq, FILFOR, forms);
  grava_req (req, bufreq);
  return (OK);
}

/* ti imp req  -  troca a impressora da requisicao 'req' para 'imp' */

troca_imp (cmd)
char *cmd;
{
  char bufreq [512], req [128], imp [128], bufimp [512];

  if (pega_linha_cmd (cmd, 2, imp) == ERRO)
    return (ERRO);
  if (pega_linha_cmd (cmd, 3, req) == ERRO)
    return (ERRO);
  if (le_req (req, bufreq) == ERRO) {
    printf ("spadm: nao existe a requisicao %s.\n", req);
    return (ERRO);
  }
  if (le_imp (imp, bufimp) == ERRO) {
    printf ("spadm: a impressora %s nao esta cadastrada.\n", imp);
    return (ERRO);
  }
  poe_cpo (bufreq, FILIMP, imp);
  grava_req (req, bufreq);
  return (OK);
}

/* vp pag imp  -  volta 'pag(s)' na impressora 'imp' */

volta_pag  (cmd)
char *cmd;
{
   char bufimp [512], imp [128], estado [128], pag [128], pida [128],
         cmdimp [128];
   int pid, aux;

   if (pega_linha_cmd (cmd, 2, pag) == ERRO)
     return (ERRO);
   if (pega_linha_cmd (cmd, 3, imp) == ERRO)
     return (ERRO);
   if (le_imp (imp, bufimp) == ERRO) {
     printf ("spadm: a impressora %s nao esta cadastrada.\n", imp);  
     return (ERRO);
   }
   if (pega_cpo (bufimp, IMPEST, estado) == ERRO) 
     return (ERRO);
   if (strcmp (estado, IMPRIMINDO) != OK) {
     printf ("spadm: impressora %s nao esta imprimindo\n", imp);
     return (ERRO);
   }
   if (pega_cpo (bufimp, IMPPID, pida))
     return (ERRO);
   pid=atoi (pida);
   aux=atoi (pag);
   sprintf (pag, "%d", aux);
   strcpy (cmdimp, "vp");
   strcat (cmdimp, pag);
   poe_cpo (bufimp, IMPCMD, cmdimp);
   grava_imp (imp, bufimp);
   kill (pid, SIGUSR1);
   return (OK);
}
