
/* spform.c  - mantem a tabela de tipos de formularios
               usage: spform [-l] [-r] [formulario]

                          -l  - lista a tabela de formularios. Se for 
                                especificado um formulario, lista somente ele.
                          -r  - remove o formulario especificado por 
                                "formulario"
                   formulario - nome do formulario a ser listado 
                                (opcao -l), ou tipo a ser criado,
                                 alterado ou removido (opcao -r) */
#include <stdio.h>
#include "spool.h"

main (argc, argv)
int argc;
char *argv[];
{
  if (argc < 2 || argc > 3)
    disp_uso_form ();

  if (!strcmp (argv [1], "-l"))
    if (argc == 2)
      lista_todos_form ();
    else
      lista_form (argv [2]); /* Manda o tipo do formulario */
  else
    if (!strcmp (argv [1], "-r")) {
      if (argc != 3)
        disp_uso_form ();
      remove_form (argv [2]);
    }
    else {
      if (argc != 2)
        disp_uso_form ();
      altinc (argv [1]);
    }
}

altinc (form)
char *form;
{
  int fdform, existe;
  char bufform [TAMFOR];

  abre (&fdform, TABFORM, "r");
  existe = pesq_reg (fdform, bufform, TAMFOR, form);
  close (fdform);
  if (existe == OK)
    altera_form (form);
  else
    inclui_form (form);
}
