
/* spimp.c - mantem a tabela de impressoras
             usage: spimp [-l] [-r] [impressora]

                          -l - lista a tabela de impressoras. Se for 
                               especificado uma impressora, lista somente ela. 
                          -r - remove a impressora especificada 
                  impressora - nome da impressora a ser listada (opcao -l),
                               ou impressora a ser criada, alterada
                               ou removida (opcao -r) */

#include <stdio.h>
#include "spool.h"

main (argc, argv)
int argc;
char *argv[];
{
  if (argc < 2 || argc > 3)
    disp_uso_imp ();

  if (!strcmp (argv[1], "-l"))
    if (argc == 2)
      lista_todos_imp ();
    else
      lista_imp (argv [2]); /* Manda a impressora */
  else
    if (!strcmp (argv[1], "-r")) {
      if (argc != 3)
        disp_uso_imp ();
      remove_imp (argv [2]); /* Manda a impressora */
    }
    else {
      if (argc != 2)
        disp_uso_imp ();
      altinc (argv [1]);
    }
}

altinc (imp)
char *imp;
{
  int fdimp, existe;
  char bufimp [TAMIMP];

  abre (&fdimp, TABIMP, "r");
  existe=pesq_reg (fdimp, bufimp, TAMIMP, imp);
  close (fdimp);
  if (existe == OK)
    altera_imp (imp);
  else
    inclui_imp (imp);
}
