/* splpr.c  - comando lpr para o spool
              sintax: splpr [-g] [-d] [-q] [-c] [-num] [-fform] \   
                      [-iimpr] [-nnome] [arquivo]     
   opcoes sem efeito  -g -d -q -c */

#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <ctype.h>
#include "spool.h"

main (argc, argv)
int argc;
char *argv[];
{
  int fdtabimp;
  char novaseq [10], nome [128], forms [50], impressora [50], device [128],
       usuario [30], copias [10], numpaginas [10], data [15], hora [15]; 
  char arqtemp [128], buffer_req [512];
  int cont, iniarq;
  int sequencia, pid;
  char *strtok (), *getenv (); /* Funcoes necessarias para o comando getenv */

  if (argc == 1)
    disp_uso ();

  /* Retira os parametros da linha de comando */

  strcpy (forms, "");
  strcpy (impressora, "");
  strcpy (copias, "1");
  strcpy (nome, "");
  iniarq=0;
  for (cont=1; cont < argc; cont++) {
    if (!strcmp (argv [cont], "-g"))
      continue;
    if (!strcmp (argv [cont], "-d"))
      continue;
    if (!strcmp (argv [cont], "-q")) 
      continue;
    if (!strcmp (argv [cont], "-c")) 
      continue;
    if (!strncmp (argv [cont], "-f", 2)) {  /* Tipo de formulario */
      char *ptr;

      ptr=argv [cont];
      strcpy (forms, ptr + 2);
      printf ("Formulario: %s\n", forms);
      continue;
    }
    if (!strncmp (argv [cont], "-i", 2)) { /* Impressora do sistema */
      char *ptr;

      ptr=argv [cont];
      strcpy (impressora, ptr + 2);
      printf ("Impressora: %s\n", impressora);
      continue;
    }
    if (!strncmp (argv [cont], "-n", 2)) { /* Titulo da requisicao */
      char *ptr;

      ptr=argv [cont];
      strcpy (nome, ptr + 2);
      printf ("Nome: %s\n", nome);
      continue;
    }
    if (!strncmp (argv [cont], "-", 1)) { /* Quantidade de copias */ 
      char *ptr;

      ptr=argv[cont];
      ptr++;
      if (isdigit((int) *ptr)) {
        strcpy (copias, ptr);
        printf ("Copias: %s\n", copias);
        continue;
      }
    }
    if (strncmp (argv [cont], "-", 1)) { /* Arquivos para a mesma requisicao */
      printf ("Arquivo: %s\n", argv [cont]);
      if (iniarq == 0) {
        iniarq = cont;
        continue;
      }
      else
        continue;
    }
  }
  if (forms == "") {
    printf ("splpr: Nao foi especificado o tipo do formulario\n.");
    exit (0);
  }

  /* Verifica a existencia e validade do dispositivo de saida */

  abre (&fdtabimp, TABIMP, "r");
  if (strlen (impressora) != 0) {
    struct stat bstat;
    char bufimp [TAMIMP];

    if (pesq_reg (fdtabimp, bufimp, TAMIMP, impressora) != OK) { 
      printf ("splpr: impressora %s nao cadastrada\n", impressora);
      exit (0);
    }
    pega_cpo (bufimp, IMPDEV, device);
    printf ("Device: %s\n", device);
    if (stat (device, &bstat) == ERRO) {
      printf ("splpr: Erro na abertura do arquivo %s\n", device);
      exit (0);
    }
  }
  else {
    printf ("splpr: A impressora destino nao foi especificada\n.");
    exit (0);
  }
  pega_data (data, hora);

  /* Coloca a requisicao na fila de impressao */

  if (iniarq == 0)
    le_stdin (arqtemp, numpaginas);
  else
    gera_tmp (argc, argv, iniarq, arqtemp, numpaginas); 

  if ((sequencia=le_sequencia ()) > 9999)
    sequencia=0;
  grava_sequencia (++sequencia);
  sprintf (novaseq, "%d", sequencia);
  strcpy (usuario, getenv ("LOGNAME"));
  if (strlen (impressora) == 0)
    strcpy (impressora, DEFAULT);
  sprintf (buffer_req, "%s:%s:%s:%s:%s:%s:%s:%s:%s:%s:%s:%s: ",
           novaseq, ATIVO, usuario, impressora, nome, arqtemp, forms,
           numpaginas, copias, data, hora, AGUARDANDOIMPR);
  for (cont=strlen (buffer_req); cont<256; cont++)
    buffer_req [cont] = BRANCO;
  buffer_req [256] = LF;
  buffer_req [257] = NULO; 
  acrescenta_fila (buffer_req);
  kill (le_pid (), SIGUSR1);
}
    
/* Le, via teclado, o arquivo para impressao.
   Recebe:  Nada.
   Retorna: O nome do arquivo temporario criado,
            numero total de paginas digitadas */

le_stdin (arqtemporario, numpaginas)
char *arqtemporario, *numpaginas;
{
  int pid;
  long data;
  int fdin, fdout;
  char buffer [512];
  int nlido, numlin, pagina;

  pid=getpid ();
  time (&data);
  sprintf (arqtemporario, strcat (DIRTMP,"%d%ld"), pid, data); 
  abre (&fdout, arqtemporario, "create");
  numlin=pagina=0;
  fdin=0; /* Le do teclado */
  while ((nlido=read (fdin, buffer, 512)) > 0) {
    char *ptr;

    for (ptr=buffer; ptr < (buffer + nlido); ptr++) {
      if (*ptr == FORMFEED) {
        pagina++;
        numlin=0;
      }
      if (*ptr == LF) {
        numlin++;
        if (numlin > 66) {
          pagina++;
          numlin=0;
        }
      }
    }
    write (fdout, buffer, nlido);
  }
  if (numlin > 0)
    pagina++;
  sprintf (numpaginas, "%d", pagina);
  close (fdout);
}
    
/* Concatena todos os arquivos requisitados em um arquivo temporario.
   Recebe:  Linha de comando argc, argv,
            Posicao inicial dos arquivos de entrada na linha de comando.
   Retorna: Nome do arquivo temporario criado,
            numero total de paginas do (grupo de) relatorio(s). */    

gera_tmp (argc, argv, inicioarq, arqtemporario, numpaginas)
int argc, inicioarq;
char *argv[], *arqtemporario, *numpaginas;
{
  int pid;
  long data;
  int fdout;
  int cont, pagina=0, numlin, nlido; 
  char buffer [512];

  pid=getpid ();
  time (&data);
  sprintf (arqtemporario, strcat (DIRTMP, "%d%ld"), pid, data); 
  abre (&fdout, arqtemporario, "create");
  for (cont=inicioarq; cont < argc; cont++) {
    int fdin;

    if (!strncmp (argv [cont], "-", 1))
      continue;
    if ((fdin=open (argv [cont], O_RDONLY)) == ERRO) {
      printf ("splpr: erro na abertura do arquivo %s\n", argv [cont]);
      exit (0);
    }
    numlin=0;
    while ((nlido=read (fdin, buffer, 512)) > 0) {
      char *ptr;

      for (ptr=buffer; ptr < (buffer + nlido); ptr++) {
        if (*ptr == FORMFEED) {
          pagina++;
          numlin=0;
        }
        if (*ptr == LF) {
          numlin++;
          if (numlin > 66) {
            pagina++;
            numlin=0;
          }
        }
      }
      write (fdout, buffer, nlido);
    }
    close (fdin);
  }
  if (numlin > 0)
    pagina++;
  close (fdout);
  sprintf (numpaginas, "%d", pagina);
}
       
pega_data (data_param, hora_param)
char *data_param, *hora_param;
{
  time_t hora;
  struct tm *data;

  time (&hora);
  data=localtime (&hora);
  data->tm_mon++;
  sprintf (data_param, "%02d.%02d.%02d",
           data->tm_mday, data->tm_mon, data->tm_year);
  sprintf (hora_param, "%02d.%02d.%02d",
           data->tm_hour, data->tm_min, data->tm_sec);
}

disp_uso ()
{
  printf ("splpr: [-g] [-d] [-q] [-c] [-fform] [-iimpr] \\ \n");
  printf ("       [-nnome] [-num] [arquivo ...]\n");
  exit (0);
}
