/* spool.h */

#define OK       0
#define ERRO     -1

#define TOKEN    ":" 

#define ACHOU    1
#define STRNULO  ""
#define ESPACO   " "
#define BRANCO   ' '
#define NULO     '\0'
#define FORMFEED '\f'
#define LF       '\n'
#ifndef NULL
#define NULL     0L
#endif

#define SIM       1
#define NAO       0
#define INVALIDO -1

/* Definicoes referentes a tabimp  (Tabela de impressoras no sistema) */

#define TABIMP   "/usr/spool/tabelas/tabimp"
#define TABNIMP  "/usr/spool/tabelas/tabnimp"
#define TAMIMP  128                  /* Tamanho maximo do registro */
#define IMPIMP    1                  /* Nome da impressora */
#define   DEFAULT    "default"
#define IMPDEV    2                  /* Nome do dispositivo da impressora */
#define IMPTIP    3                  /* Tipo da impressora */
#define IMPEST    4                  /* Estado em que a impres.se encontra */
#define   IMPRIMINDO "imprimindo" 
#define   ATIVADA    "ativada"
#define   DESATIVADA "desativada"
#define IMPFOR    5                  /* Formulario corrente */
#define IMPCMD    6                  /* Comando para a impressora */ 
#define   PARARIMPR    "pi"
#define   CONTINUAIMPR "ct" 
#define   ABANDONE     "ab"
#define   REIMPRIMIR   "ai"
#define   VOLTAPAGINA  "vp"
#define   AVANCAPAG    "ap"
#define   NORMAL       "no"
#define IMPPID    7                  /* Pid do spooler ativo da impressora */
#define IMPREQ    8                  /* Ultima requisicao para impressao */
#define IMPPAG    9                  /* pagina corrente */

/* Definicoes referentes a tabform  (Tabela de formularios) */

#define TABFORM  "/usr/spool/tabelas/tabform" 
#define TABNFORM "/usr/spool/tabelas/tabnform"
#define TAMFOR  128                  /* Tamanho maximo do registro */
#define FORFOR    1                  /* Nome do formulario */
#define FORLIN    2                  /* Tamanho da pagina em linhas */
#define FORENT    3                  /* Espacamento entre linhas 1/6 1/8 */
#define FORCOM    4                  /* Impressao normal ou comprimido */
#define FORPAD    5                  /* Qualidade carta ou nao */

/* Definicoes referentes a tabimp  (Tabela de tipod de impressoras) */

#define TABTIPO  "/usr/spool/tabelas/tabtipo" 
#define TABNTIPO "/usr/spool/tabelas/tabntipo" 
#define TAMTIP  128                  /* Tamanho maximo do formulario */
#define TIPTIP    1                  /* Tipo do formulario */ 
#define TIPINI    2                  /* Sequencia para inicio de impressao */
#define TIPFIM    3                  /* Sequencia p/filanizacao de impres. */
#define TIPNOR    4                  /* Impressao normal */
#define TIPCOM    5                  /* Impressao comprimida */
#define TIPPAG    6                  /* Tamanho do pagina */
#define TIPSEX    7                  /* Impressao em 1/6 de espacamento */
#define TIPOIT    8                  /* Impressao em 1/8 de espacamento */
#define TIPCAR    9                  /* Impressao em qualidade carta */

/* Definicoes referentes a tabfila  (Fila de impressao) */

#define TABFILA  "/usr/spool/tabelas/tabfila"
#define TABNFILA "/usr/spool/tabelas/tabnfila"
#define TAMFIL  256                  /* Tamanho maximo do registro */
#define FILREQ    1                  /* Numero da requisicao de impressao */
#define FILSTA    2                  /* Status do registro */
#define   ATIVO    "ok"
#define   DELETADO "del"
#define FILUSU    3                  /* usuario dono do relatorio */
#define FILIMP    4                  /* Impressora destino */
#define FILTIT    5                  /* Nome (titulo) do relatorio */
#define FILARQ    6                  /* Nome do arquivo no sistema */
#define FILFOR    7                  /* Tipo do formulario */
#define FILPAG    8                  /* Numero de paginas */
#define FILCOP    9                  /* Numero do copias */
#define FILDAT   10                  /* Data da geracao do relatorio */
#define FILHOR   11                  /* Hora da geracao do relatorio */
#define FILSIT   12                  /* Status do relatorio */
#define   SENDOIMPRESSO  "im"
#define   AGUARDANDOIMPR "ai"
#define   IMPRESSO       "ip"

#define TABSEQ   "/usr/spool/tabelas/tabseq"
#define TAMSEQ   512

#define TABPID   "/usr/spool/tabelas/tabpid"
#define TAMPID   512

#define DIRTMP  "/usr/spool/relatorios/"
