/* spooler  */

#define TAM_BUF  4096 /* Tamanho do buffer de leitura do arquivo fonte */

#include <stdio.h>
#include <signal.h>
#include "spool.h"

/* Variaveis globais para a funcao exec_cmd atuar normalmente */

int exec_cmd ();
char req [60], impr [60];
int fdarq, nlido, pagina_atual=0;
int parar_impr=0;

main (argc, argv)
int argc;
char *argv[];
{
  /* Fila de Impressao */
  char usuario [60], titulo [60], arq [60],
       forms [60], asc_pagina [60], asc_copia [60], data [60], hora [60],
       estado [60];
  char buffer [512];
  int pagina, copia;

  /* Tabela de Impressoras do sistema */
  char device [100], tipo [40], buffer_imp [512], pid_imp [20];
  int fdimp;

  /* Outras variaveis */
  char asc_pag_atual [10];
  int cont, nlf=0;

  strcpy (req, argv [1]); 
  le_req (req, buffer);
  pega_cpo (buffer, FILUSU, usuario);
  pega_cpo (buffer, FILIMP, impr);
  pega_cpo (buffer, FILTIT, titulo);
  pega_cpo (buffer, FILARQ, arq);
  pega_cpo (buffer, FILFOR, forms);
  pega_cpo (buffer, FILPAG, asc_pagina);
  pega_cpo (buffer, FILCOP, asc_copia);
  pega_cpo (buffer, FILDAT, data);
  pega_cpo (buffer, FILHOR, hora);
  pega_cpo (buffer, FILSIT, estado);
  pagina=atoi (asc_pagina);
  copia=atoi (asc_copia);
  if (le_imp (impr, buffer_imp) == ERRO) { /* a rotina le_imp ja emite */
    kill (le_pid (), SIGUSR1);             /* mensagem de erro.        */ 
    exit (0);
  } 
  sprintf (pid_imp, "%d", getpid ());
  poe_cpo (buffer_imp, IMPPID, pid_imp);
  grava_imp (impr, buffer_imp);
  pega_cpo (buffer_imp, IMPDEV, device);
  pega_cpo (buffer_imp, IMPTIP, tipo);
  abre (&fdimp, device, "w");
  abre (&fdarq, arq, "r");
  inicializa_impressao (fdimp, tipo, forms);
  signal (SIGUSR1, exec_cmd);
  for (cont=1; cont <= copia; cont++) {
    int resp;
    char buf [TAM_BUF];

    nlido=1;
    lseek (fdarq, 0L, 0);
    while (nlido) {
      if ((nlido=read (fdarq, buf, TAM_BUF)) != 0) {
        int pos;
        char *ptr;
  
        for (ptr=buf; ptr < &buf[nlido]; ptr++) 
          if (*ptr == FORMFEED || nlf > 66) {
            nlf=0;
            pagina_atual++;
          }
          else
            if (*ptr == LF)
              nlf++;
        if (parar_impr == -1)
          pause ();
        write (fdimp, buf, nlido);
      }
      sprintf (asc_pag_atual, "%d", pagina_atual);
      poe_cpo (buffer_imp, IMPPAG, asc_pag_atual);
      grava_imp (impr, buffer_imp);
    }
  }
  finaliza_impressao (fdimp, tipo); 
  poe_cpo (buffer, FILSIT, IMPRESSO);
  grava_req (req, buffer);
  poe_cpo (buffer_imp, IMPEST, ATIVADA);
  grava_imp (impr, buffer_imp); 
  close (fdarq);
  close (fdimp);
  kill (le_pid (), SIGUSR1);   
}

inicializa_impressao (fdimp, tipo, form)
int fdimp;
char *tipo, *form;
{
  char buffer_form [512], tamfor [20], entrelac [20],
       normcomp [40], carta [40];
  char buffer_tipo [512], seqini [20], seqpag [20],
       seq_entr [20], seq_nmcp [40], seqct [40];
  char buffer_impr [512];

  if (le_form (form, buffer_form) == ERRO) {
    printf ("Spooler: Formulario %s nao cadastrado\n", form);
    kill (le_pid (), SIGUSR1);   
    exit (0);
  }
  if (le_tipo (tipo, buffer_tipo) == ERRO) {
    printf ("Spooler: Tipo de impressora %s nao cadastrada/n", tipo);
    kill (le_pid (), SIGUSR1);   
    exit (0);
  }
  
  pega_cpo (buffer_tipo, TIPINI, seqini); /* Sequencia p/inicio de impressao */
  strcpy (buffer_impr, seqini);

  pega_cpo (buffer_form, FORLIN, tamfor); /* Setagem do tamanho de pagina */
  pega_cpo (buffer_tipo, TIPPAG, seqpag);
  strcat (buffer_impr, seqpag);
  strcat (buffer_impr, tamfor);

  pega_cpo (buffer_form, FORENT, entrelac); /* Setagem entrelacamento 1/6,1/8 */
  if (!strcmp (entrelac, "sexto"))  
    pega_cpo (buffer_tipo, TIPSEX, seq_entr);
  else
    pega_cpo (buffer_tipo, TIPOIT, seq_entr);
  strcat (buffer_impr, seq_entr);  

  pega_cpo (buffer_form, FORCOM, normcomp); /* Formul.normal ou comprimido */
  if (!strcmp (normcomp, "normal")) 
    pega_cpo (buffer_tipo, TIPNOR, seq_nmcp);
  else
    pega_cpo (buffer_tipo, TIPCOM, seq_nmcp);
  strcat (buffer_impr, seq_nmcp);

  pega_cpo (buffer_form, FORPAD, carta); /* Impr. qualidade carta ou normal */
  if (strcmp (carta, "padrao")) {
    pega_cpo (buffer_tipo, TIPCAR, seqct);
    strcat (buffer_impr, seqct);
  }   
 
  write (fdimp, buffer_impr, strlen (buffer_impr));
}


finaliza_impressao (fdimp, tipo)
int fdimp;
char *tipo;
{
  char buffer_tipo [512], seqfim [20];
  char buffer_impr [512];

  if (le_tipo (tipo, buffer_tipo) == ERRO) {
    printf ("Spooler: Tipo de impressora %s nao cadastrada/n", tipo);
    kill (le_pid (), SIGUSR1);   
    exit (0);
  }
  
  pega_cpo (buffer_tipo, TIPFIM, seqfim); /* Sequencia p/fim de impressao */
  strcpy (buffer_impr, seqfim);
 
  write (fdimp, buffer_impr, strlen (buffer_impr));
}

exec_cmd ()
{
  char buffer_imp [512], buffer [512], cmd [10];
   
  le_imp (impr, buffer_imp);
  pega_cpo (buffer_imp, IMPCMD, cmd); 
  le_req (req, buffer);
  if (!strcmp (cmd, PARARIMPR)) 
    parar_impr=-1;
  else
    if (!strncmp (cmd, VOLTAPAGINA, strlen (VOLTAPAGINA))) {
      char *asc_pag;
      int pag;
      char buffer [512], *ptr;
      int pagaux=0, nlf=0, nlido;
      
      asc_pag=cmd;
      asc_pag+=strlen (VOLTAPAGINA); /* o numero da pagina e precedido */
      pag=atoi (asc_pag);            /* pela identificacao do comando. */
      if (pag < 0)
        pagina_atual=0;
      else
        pagina_atual-=pag;   
      lseek (fdarq, 0L, 0);
      while (pagaux < pagina_atual) {
        nlido=read (fdarq, buffer, TAM_BUF);
        for (ptr = buffer; ptr < &buffer [nlido]; ptr++)
          if (*ptr == FORMFEED || nlf > 66) {
            nlf=0;
            pagaux++;
          }
          else
            if (*ptr == LF)
              nlf ++;
      } 
      poe_cpo (buffer_imp, IMPCMD, NORMAL);   
      grava_imp (impr, buffer_imp);
    }
    else
      if (!strncmp (cmd, AVANCAPAG, strlen (AVANCAPAG))) {
        char *asc_pag;
        int pag;
        char buffer [512], *ptr;
        int pagaux, nlf=0, nlido;
        
        asc_pag=cmd;
        asc_pag+=strlen (AVANCAPAG);   /* o numero da pagina e precedido */
        pag=atoi (asc_pag);            /* pela identificacao do comando. */
        pagaux=pagina_atual;
        pagina_atual+=pag;
        if (pagina_atual<0)
          pagina_atual=0;
        while (pagaux < pagina_atual) {
          nlido=read (fdarq, buffer, TAM_BUF);
          for (ptr = buffer; ptr < &buffer [nlido]; ptr++)
            if (*ptr == FORMFEED || nlf > 66) {
              nlf=0;
              pagaux++;
            }
            else
              if (*ptr == LF)
                nlf ++;
        }   
        poe_cpo (buffer_imp, IMPCMD, NORMAL);
        grava_imp (impr, buffer_imp);
      }
      else
        if (!strcmp (cmd, CONTINUAIMPR)) {
          poe_cpo (buffer_imp, IMPCMD, NORMAL);
          grava_imp (impr, buffer_imp);
          parar_impr=0;
        }
        else
          if (!strcmp (cmd, ABANDONE)) {
            poe_cpo (buffer, FILSIT, IMPRESSO);
            grava_req (req, buffer);
            poe_cpo (buffer_imp, IMPEST, ATIVADA);
            grava_imp (impr, buffer_imp);
            kill (le_pid (), SIGUSR1);   
            exit (0);
          } 
  signal (SIGUSR1, exec_cmd);
}
