/* sptipo.c  - mantem a tabela de tipos de impressoras
   usage: sptipo [-l] [-r] [tipo]

                          -l  - lista a tabela de tipos. Se for especificado
                                um tipo, lista somente ele.
                          -r  - remove o tipo especificado
                        tipo  - tipo da impressora a ser listado (opcao -l),
                                ou tipo a ser criado, alterado ou removido
                                (opcao -r) */
#include <stdio.h>
#include "spool.h"

main (argc, argv)
int argc;
char *argv[];
{
  if (argc < 2 || argc > 3)
    disp_uso_tipo ();

  if (!strcmp (argv[1], "-l")) 
    if (argc == 2)
      lista_todos_tipo ();
    else 
      lista_tipo (argv [2]); /* Manda o tipo da impressora */
  else 
    if (!strcmp (argv[1], "-r")) {
      if (argc != 3)
        disp_uso_tipo ();
      remove_tipo (argv [2]); /* Manda o tipo da impressora */
    }
    else {
      if (argc != 2) 
        disp_uso_tipo ();
      altinc (argv [1]);
    }
}

altinc (tipo)
char *tipo;
{
  int  fdtipo, existe;
  char buftipo [TAMTIP];

  abre (&fdtipo, TABTIPO, "r+w");
  existe=pesq_reg (fdtipo, buftipo, TAMTIP, tipo);
  close (fdtipo);
  if (existe == OK)
    altera_tipo (tipo); 
  else 
    inclui_tipo (tipo);
}
